{{/* vim: set filetype=mustache: */}}
{{/*
Return the proper image name
{{ include "platform.images.image" ( dict "imageRoot" .Values.path.to.the.image "global" $) }}
*/}}
{{- define "platform.images.image" -}}
{{- $registryName := index .imageRoot "registry" -}}
{{- $repositoryName := index .imageRoot "repository" -}}
{{- $tag := .imageRoot.tag | toString -}}
{{- if .global }}
     {{- $registryName = .global.image.registry -}}
     {{- $tag = .global.image.tag -}}
{{- end -}}
{{- if $registryName }}
{{- if and ( get .imageRoot "digest_name") ( index .global ( get .imageRoot "digest_name" ) ) -}}
{{- printf "%s/%s@%s" $registryName $repositoryName ( index .global .imageRoot.digest_name ) -}}
{{- else -}}
{{- printf "%s/%s:%s" $registryName $repositoryName $tag -}}
{{- end -}}
{{- else -}}
{{- printf "%s:%s" $repositoryName $tag -}}
{{- end -}}
{{- end -}}

